/*
 * trAIns - An AI for OpenTTD
 * Copyright (C) 2009  Luis Henrique O. Rios
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
*/


class IndustryManager {
	/* Public: */
	constructor(){
		industry_list = AIList();
		industry_list.AddList(AIIndustryList());
	}
	function IsIndustryBlocked(industry_id);
	function BlockIndustry(industry_id);
	function IndustryOpen(industry_id);
	function IndustryClose(industry_id);

	/* Private: */
	static BLOCKAGE_DURATION = 365 * 2;/* days. */

	industry_list = null;
}

function IndustryManager::IsIndustryBlocked(industry_id){
	if(!industry_list.HasItem(industry_id)){
		industry_list.AddItem(industry_id , 0);
		return false;
	}else{
		local blockage_time = industry_list.GetValue(industry_id);
		if(AIDate.GetCurrentDate() - blockage_time > BLOCKAGE_DURATION){
			industry_list.SetValue(industry_id , 0);
			return false;
		}
	}
	return true;
}

function IndustryManager::BlockIndustry(industry_id){
	if(!industry_list.HasItem(industry_id)){
		industry_list.AddItem(industry_id , AIDate.GetCurrentDate());
		assert(0);
	}else{
		industry_list.SetValue(industry_id , AIDate.GetCurrentDate());
	}
}

function IndustryManager::IndustryOpen(industry_id){
	if(industry_list.HasItem(industry_id)) industry_list.RemoveItem(industry_id);
	industry_list.AddItem(industry_id , 0);
}

function IndustryManager::IndustryClose(industry_id){
	if(industry_list.HasItem(industry_id)) industry_list.RemoveItem(industry_id);
}
